
FUNCTION $1_Clear ()
	SHARED $1 $1_pool[]
	SHARED $1_poolUM[]

	$1 $1_null

	FOR slot = UBOUND ($1_poolUM[]) TO 0 STEP -1
		$1_pool[slot] = $1_null
		$1_poolUM[slot] = $$FALSE
	NEXT slot
END FUNCTION

FUNCTION $1_Delete ($1_id)
	SHARED $1 $1_pool[]
	SHARED $1_poolUM[]

	$1 $1_null

	bOK = $$FALSE
	slot = $1_id - 1
	IF (slot >= 0) && (slot <= UBOUND ($1_poolUM[])) THEN
		$1_pool[slot] = $1_null
		$1_poolUM[slot] = $$FALSE
		bOK = $$TRUE
	ENDIF
	RETURN bOK
END FUNCTION

FUNCTION $1_Get ($1_id, $1 $1_item)
	SHARED $1 $1_pool[]
	SHARED $1_poolUM[]

	$1 $1_null

	bOK = $$FALSE
	slot = $1_id - 1
	IF (slot >= 0) && (slot <= UBOUND ($1_poolUM[])) THEN
		IF $1_poolUM[slot] THEN
			$1_item = $1_pool[slot]
			bOK = $$TRUE
		ENDIF
	ENDIF
	IFF bOK THEN
		$1_item = $1_null
	ENDIF
	RETURN bOK
END FUNCTION

FUNCTION $1_Get_idMax ()
	SHARED $1_poolUM[]

	idMax = 0
	IF $1_poolUM[] THEN
		FOR slot = UBOUND ($1_poolUM[]) TO 0 STEP -1
			IF $1_poolUM[slot] THEN
				idMax = slot + 1
				EXIT FOR
			ENDIF
		NEXT slot
	ENDIF
	RETURN idMax
END FUNCTION

FUNCTION $1_Get_name$ ($1_id)
	SHARED $1 $1_pool[]
	SHARED $1_poolUM[]

	bOK = $$FALSE
	slot = $1_id - 1
	IF (slot >= 0) && (slot <= UBOUND ($1_poolUM[])) THEN
		IF $1_poolUM[slot] THEN
			bOK = $$TRUE
			$1_name$ = RTRIM$ ($1_pool[slot].name)
		ENDIF
	ENDIF
	IFF bOK THEN
		$1_name$ = ""
	ENDIF
	RETURN $1_name$
END FUNCTION

FUNCTION $1_Init ()
	SHARED $1 $1_pool[]
	SHARED $1_poolUM[]

	$1 $1_null

	IFZ $1_pool[] THEN
		DIM $1_pool[7]
		DIM $1_poolUM[7]
	ENDIF
	FOR slot = UBOUND ($1_poolUM[]) TO 0 STEP -1
		$1_pool[slot] = $1_null
		$1_poolUM[slot] = $$FALSE
	NEXT slot
END FUNCTION

FUNCTION $1_New ($1 $1_item)
	SHARED $1 $1_pool[]
	SHARED $1_poolUM[]

	$1 $1_null

	IFZ $1_poolUM[] THEN $1_Init ()

	slotNew = -1

	upper_slot = UBOUND ($1_poolUM[])
	FOR slot = 0 TO upper_slot
		IFF $1_poolUM[slot] THEN
			slotNew = slot
			EXIT FOR
		ENDIF
	NEXT slot

	IF (slotNew < 0) THEN
		slotNew = upper_slot + 1
		upp = (slotNew << 1) | 3
		REDIM $1_pool[upp]
		REDIM $1_poolUM[upp]
		FOR i = slotNew TO upp
			$1_pool[i] = $1_null
		NEXT i
	ENDIF

	IF (slotNew >= 0) THEN
		$1_pool[slotNew] = $1_item
		$1_poolUM[slotNew] = $$TRUE
	ENDIF
	RETURN (slotNew + 1)
END FUNCTION

FUNCTION $1_Update ($1_id, $1 $1_item)
	SHARED $1 $1_pool[]
	SHARED $1_poolUM[]

	bOK = $$FALSE
	slot = $1_id - 1
	IF (slot >= 0) && (slot <= UBOUND ($1_poolUM[])) THEN
		IF $1_poolUM[slot] THEN
			$1_pool[slot] = $1_item
			bOK = $$TRUE
		ENDIF
	ENDIF
	RETURN bOK
END FUNCTION