CONSOLE
'
' Validation of pool TEST
'
	IMPORT "xst"         ' Xblite Standard Library
	IMPORT "xsx"         ' Xblite Standard eXtended Library
'
'
TYPE TEST
	STRING*30 .name30		' name (30 char max)
	XLONG     .type		' type
END TYPE
'
DECLARE FUNCTION Entry () ' program entry point
'
' === TEST pool ===
'
GRAB "verbose/accessors/declare.x"
' "$1" := "TEST"
' ".name" := ".name30"
'
GRAB "verbose/accessors/declare02.x" ' "$1" := "TEST"

FUNCTION Entry ()
	TEST TEST_item

	? "Validation of pool TEST"
	? "=================="
	?
	bInvalid = $$FALSE		' assume valid

	TEST_Init ()		' initialize the TEST pool

	? "adding 20 items for testing."
	?

	FOR n = 1 TO 20
		TEST_item.name30 = LCASE$ ("TEST") + FORMAT$ ("00", n)
		? "Adding TEST item '"; TEST_item.name30; "'"
		TEST_idNew = TEST_New (TEST_item)
		IFZ TEST_idNew THEN PRINT "TEST_New: Can't add item '"; TEST_item.name30; "' to the TEST pool"
	NEXT n
	TEST_idMaxOld = TEST_Get_idMax ()

' (Validation of pool's id, count and getter)
	?
	TEST_count = TEST_Get_count ()
	? "List all"; TEST_count; " items"

	FOR TEST_id = 1 TO TEST_idMaxOld
		bOK = TEST_Get (TEST_id, @TEST_item)
		IFF bOK THEN		' deleted
			? "TEST_Get: Can't get TEST item"; TEST_id
		ELSE
			IF TEST_id < 10 THEN id$ = " " + STRING$ (TEST_id) ELSE id$ = STRING$ (TEST_id)
			? id$; ". '"; TEST_item.name30; "'"
		ENDIF
	NEXT TEST_id

' (Validation of pool's delete routine)
	?
	? "Deleting first  item"
	TEST_idMin = TEST_Get_idMin ()
	bOK = TEST_Delete (TEST_idMin)
	IFF bOK THEN ? "Error: first item was NOT deleted"

	? "Deleting second item"
	TEST_idMin = TEST_Get_idMin ()
	bOK = TEST_Delete (TEST_idMin)
	IFF bOK THEN ? "Error: first item was NOT deleted"

	? "Deleting last   item"
	TEST_idMaxOld = TEST_Get_idMax ()
	bOK = TEST_Delete (TEST_idMaxOld)
	IFF bOK THEN ? "Error: last item was NOT deleted"

' (Validation of pool's add routine)
	TEST_item.name30 = "new_item01"
	? "Adding TEST_item.name30 first item "; TEST_item.name30
	TEST_idNew = TEST_New (TEST_item)
	IFZ TEST_idNew THEN PRINT "TEST_New: Can't add item = "; TEST_item.name30; " to its pool TEST"

	?
	TEST_idMin = TEST_Get_idMin ()
	? "First item id:"; TEST_idMin

	TEST_idMaxOld = TEST_Get_idMax ()
	? "Last  item id:"; TEST_idMaxOld
	? "Item count   :"; TEST_Get_count ()
	?
	? "List all"; TEST_Get_count (); " items"
	FOR TEST_id = TEST_idMin TO TEST_idMaxOld
		bOK = TEST_Get (TEST_id, @TEST_item)
		IF bOK THEN
			IF TEST_id < 10 THEN id$ = " " + STRING$ (TEST_id) ELSE id$ = STRING$ (TEST_id)
			? id$; ". '"; TEST_item.name30; "'"
		ELSE
			IF TEST_Active (TEST_id) THEN
				? "TEST item"; TEST_id; " was NOT deleted; bad!"
			ELSE
				? "TEST item"; TEST_id; " was deleted; OK!"
			ENDIF
		ENDIF
	NEXT TEST_id

	?
	?
	? "Same list using TEST_GetNext"

	' *** walk thru the TEST pool
	b1stTime = $$TRUE
	TEST_id = 0
	DO WHILE TEST_GetNext (@TEST_id, @TEST_item)
		IF TEST_id < 10 THEN id$ = " " + STRING$ (TEST_id) ELSE id$ = STRING$ (TEST_id)
		IF b1stTime THEN
			b1stTime = $$FALSE
			? id$; ". '"; TEST_Get_name$ (TEST_id); "' (first item)"
		ELSE
			? id$; ". '"; TEST_item.name30; "'"
		ENDIF
		'
		IFF TEST_Active (TEST_id) THEN
			? "TEST item"; TEST_id; " was deleted; error"
			bInvalid = $$TRUE
		ENDIF
	LOOP
	IFZ TEST_id THEN
		? "TEST pool is empty"
	ENDIF

' (Validation of pool's clear routine)
	?
	? "Validation of TEST_Clear()"

	TEST_Clear ()		' clear TEST pool

	TEST_id = 0
	DO WHILE TEST_GetNext (@TEST_id, @TEST_item)
		IF TEST_id < 10 THEN id$ = " " + STRING$ (TEST_id) ELSE id$ = STRING$ (TEST_id)
		? id$; ". '"; TEST_item.name30; "'"
	LOOP

	IFZ TEST_id THEN
		? "TEST pool is empty; OK!"
	ELSE
		? "TEST pool is NOT empty; error"
		bInvalid = $$TRUE
	ENDIF

	IF TEST_Get_count () THEN
		? "TEST pool is NOT empty; error"
		bInvalid = $$TRUE
	ENDIF
	?
	?
	IF bInvalid THEN
		? "?????????????????????"
		? "? Invalid pool TEST ?"
		? "?????????????????????"
	ELSE
		? "********************"
		? "* Pool TEST is OK! *"
		? "********************"
	ENDIF

	a$ = INLINE$ ("\nPress Enter to quit >")
	QUIT (0)

END FUNCTION
'
'
' === TEST pool ===
'
GRAB "verbose/accessors/define.x"
' "$1" := "TEST"
' ".name" := ".name30"
'
GRAB "verbose/accessors/define02.x" ' "$1" := "TEST"

END PROGRAM