; Zero memory (386 and above code)
; - $1: FUNCTION name
; - $2: unique jump tag inside FUNCTION $1
;
; Usage:
; --- XBLite code to uncomment ---
;	'ZeroMemory (&WIN_pool[0], SIZE (WIN_pool[]))
;
;	destAddr = &WIN_pool[0]
;	bytes = SIZE (WIN_pool[])
;
;GRAB "verbose\\ZeroMemory.asm"
;' "$1" := "GenReorg"
;' "$2" := "Z001"

	push	edi
	push	ecx

; load in edi the address of the string to pad with binary zeroes
	mov edi,[$1.sourceAddr]
	test edi,edi
	jz > $1.$2.zero.end		; null address

; load in ecx the number of padding zero bytes
	mov	ecx,[$1.bytes]
	jecxz > $1.$2.zero.end

; compute a 32bit-word count (32bit-word == 4 bytes)
	shr	ecx,2		; divide the byte count by 4
	jecxz > $1.$2.zero.tail

	mov	eax,0
	cld
	rep stosd

$1.$2.zero.tail:
; reload the zero byte count
	mov	ecx,[$1.bytes]

; compute the remaining byte count
	and	ecx,3		; compute the modulo of the byte count by 4
	jecxz > $1.$2.zero.end

; pad with up to 3 zero bytes
	mov	eax,0
	cld
	rep stosb

$1.$2.zero.end:
	pop	ecx
	pop	edi
